<html>
<head>
<title>OgreGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GpuProgram_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GpuProgram_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreSerializer_8h.html">OgreSerializer.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgramParams_8h.html">OgreGpuProgramParams.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00049"></a><a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">00049</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a><a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976ea3d96c54ace718f26c66067503efd56a3">00051</a>         <a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976ea3d96c54ace718f26c66067503efd56a3">GPT_VERTEX_PROGRAM</a>,
<a name="l00052"></a><a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976eac9a00b013e9075bc061b0585cf9a6c3b">00052</a>         <a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976eac9a00b013e9075bc061b0585cf9a6c3b">GPT_FRAGMENT_PROGRAM</a>,
<a name="l00053"></a><a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976ea78fc6b12cad0b4a28e86c802ee50bcdd">00053</a>         <a class="code" href="group__Resources.html#ggad08e89fa63e81d061ea9e2f37664976ea78fc6b12cad0b4a28e86c802ee50bcdd">GPT_GEOMETRY_PROGRAM</a>
<a name="l00054"></a>00054     };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     <span class="comment">// Forward declaration </span>
<a name="l00058"></a>00058     <span class="keyword">class </span>GpuProgramPtr;
<a name="l00059"></a>00059 
<a name="l00069"></a><a class="code" href="classOgre_1_1GpuProgram.html">00069</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071     <span class="keyword">protected</span>:
<a name="l00073"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdType.html">00073</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdType.html" title="Command object - see ParamCommand.">CmdType</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075         <span class="keyword">public</span>:
<a name="l00076"></a>00076             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00077"></a>00077             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00078"></a>00078         };
<a name="l00079"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdSyntax.html">00079</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdSyntax.html">CmdSyntax</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081         <span class="keyword">public</span>:
<a name="l00082"></a>00082             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00083"></a>00083             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00084"></a>00084         };
<a name="l00085"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdSkeletal.html">00085</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdSkeletal.html">CmdSkeletal</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087         <span class="keyword">public</span>:
<a name="l00088"></a>00088             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00089"></a>00089             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00090"></a>00090         };
<a name="l00091"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdMorph.html">00091</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdMorph.html">CmdMorph</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093         <span class="keyword">public</span>:
<a name="l00094"></a>00094             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00095"></a>00095             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00096"></a>00096         };
<a name="l00097"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdPose.html">00097</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdPose.html">CmdPose</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00098"></a>00098         {
<a name="l00099"></a>00099         <span class="keyword">public</span>:
<a name="l00100"></a>00100             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00101"></a>00101             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00102"></a>00102         };
<a name="l00103"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdVTF.html">00103</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdVTF.html">CmdVTF</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105         <span class="keyword">public</span>:
<a name="l00106"></a>00106             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00107"></a>00107             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00108"></a>00108         };
<a name="l00109"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdManualNamedConstsFile.html">00109</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdManualNamedConstsFile.html">CmdManualNamedConstsFile</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111         <span class="keyword">public</span>:
<a name="l00112"></a>00112             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00113"></a>00113             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00114"></a>00114         };
<a name="l00115"></a><a class="code" href="classOgre_1_1GpuProgram_1_1CmdAdjacency.html">00115</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdAdjacency.html">CmdAdjacency</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00116"></a>00116         {
<a name="l00117"></a>00117         <span class="keyword">public</span>:
<a name="l00118"></a>00118             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00119"></a>00119             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00120"></a>00120         };
<a name="l00121"></a>00121         <span class="comment">// Command object for setting / getting parameters</span>
<a name="l00122"></a><a class="code" href="classOgre_1_1GpuProgram.html#a429e2ecd6f4167c00d0d7f0b68893276">00122</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdType.html" title="Command object - see ParamCommand.">CmdType</a> <a class="code" href="classOgre_1_1GpuProgram.html#a429e2ecd6f4167c00d0d7f0b68893276">msTypeCmd</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1GpuProgram.html#afb9dd8af84fcf198db56aeab298990dd">00123</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdSyntax.html">CmdSyntax</a> <a class="code" href="classOgre_1_1GpuProgram.html#afb9dd8af84fcf198db56aeab298990dd">msSyntaxCmd</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1GpuProgram.html#ac3d70ea16cb2beb8aa201db048cc35e9">00124</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdSkeletal.html">CmdSkeletal</a> <a class="code" href="classOgre_1_1GpuProgram.html#ac3d70ea16cb2beb8aa201db048cc35e9">msSkeletalCmd</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1GpuProgram.html#a828a927b860e3c074704399336f95160">00125</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdMorph.html">CmdMorph</a> <a class="code" href="classOgre_1_1GpuProgram.html#a828a927b860e3c074704399336f95160">msMorphCmd</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1GpuProgram.html#a015fc5be549ef103862dcd152fcf0f3a">00126</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdPose.html">CmdPose</a> <a class="code" href="classOgre_1_1GpuProgram.html#a015fc5be549ef103862dcd152fcf0f3a">msPoseCmd</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1GpuProgram.html#abe51b99e867a315e2b2ebcc89e601277">00127</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdVTF.html">CmdVTF</a> <a class="code" href="classOgre_1_1GpuProgram.html#abe51b99e867a315e2b2ebcc89e601277">msVTFCmd</a>;
<a name="l00128"></a><a class="code" href="classOgre_1_1GpuProgram.html#aed57c301ea07b1c183f1c351707396d5">00128</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdManualNamedConstsFile.html">CmdManualNamedConstsFile</a> <a class="code" href="classOgre_1_1GpuProgram.html#aed57c301ea07b1c183f1c351707396d5">msManNamedConstsFileCmd</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1GpuProgram.html#ae55ec6363600c10db68ff17b35437889">00129</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgram_1_1CmdAdjacency.html">CmdAdjacency</a> <a class="code" href="classOgre_1_1GpuProgram.html#ae55ec6363600c10db68ff17b35437889">msAdjacencyCmd</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1GpuProgram.html#ab201a6fcb1c568967d01f22906ecdff1">00131</a>         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="classOgre_1_1GpuProgram.html#ab201a6fcb1c568967d01f22906ecdff1" title="The type of the program.">mType</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1GpuProgram.html#a8734503d5521ae7adaceba487b88fe55">00133</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GpuProgram.html#a8734503d5521ae7adaceba487b88fe55" title="The name of the file to load source from (may be blank)">mFilename</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1GpuProgram.html#a80f6f65a2ec5a02a4c56458bd2b35b18">00135</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GpuProgram.html#a80f6f65a2ec5a02a4c56458bd2b35b18" title="The assembler source of the program (may be blank until file loaded)">mSource</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1GpuProgram.html#a606d51d653a0dda9d61508851441dc8a">00137</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a606d51d653a0dda9d61508851441dc8a" title="Whether we need to load source from file or not.">mLoadFromFile</a>;
<a name="l00139"></a><a class="code" href="classOgre_1_1GpuProgram.html#a1244023352bf866592f904bd3dfa404f">00139</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GpuProgram.html#a1244023352bf866592f904bd3dfa404f" title="Syntax code e.g. arbvp1, vs_2_0 etc.">mSyntaxCode</a>;
<a name="l00141"></a><a class="code" href="classOgre_1_1GpuProgram.html#a96cb132e0bac4820e9917ebc9151fe69">00141</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a96cb132e0bac4820e9917ebc9151fe69" title="Does this (vertex) program include skeletal animation?">mSkeletalAnimation</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1GpuProgram.html#a8a0271c814c3ffd4ae079ae1e4b11404">00143</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a8a0271c814c3ffd4ae079ae1e4b11404" title="Does this (vertex) program include morph animation?">mMorphAnimation</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1GpuProgram.html#a398053069a0c61809193079501b0abb5">00145</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1GpuProgram.html#a398053069a0c61809193079501b0abb5" title="Does this (vertex) program include pose animation (count of number of poses supported)">mPoseAnimation</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1GpuProgram.html#a7012d5855d4f70388bbee4940466a606">00147</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a7012d5855d4f70388bbee4940466a606" title="Does this (vertex) program require support for vertex texture fetch?">mVertexTextureFetch</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1GpuProgram.html#a5e20e45a9ca8fe4c99a04c34ef3d7275">00149</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a5e20e45a9ca8fe4c99a04c34ef3d7275" title="Does this (geometry) program require adjacency information?">mNeedsAdjacencyInfo</a>;
<a name="l00151"></a><a class="code" href="classOgre_1_1GpuProgram.html#ab103ebff6dfda04861947cbf1a941596">00151</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1GpuProgram.html#ab103ebff6dfda04861947cbf1a941596" title="The default parameters for use with this object.">mDefaultParams</a>;
<a name="l00153"></a><a class="code" href="classOgre_1_1GpuProgram.html#ab2bb4597b7fb640dee90589b8fbbc4f2">00153</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#ab2bb4597b7fb640dee90589b8fbbc4f2" title="Did we encounter a compilation error?">mCompileError</a>;
<a name="l00158"></a><a class="code" href="classOgre_1_1GpuProgram.html#aa729a7bcc7c5a622fffe5869d69c05bc">00158</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuLogicalBufferStructPtr</a> <a class="code" href="classOgre_1_1GpuProgram.html#aa729a7bcc7c5a622fffe5869d69c05bc" title="Record of logical to physical buffer maps.">mFloatLogicalToPhysical</a>;
<a name="l00163"></a><a class="code" href="classOgre_1_1GpuProgram.html#a943cefa6be84842ec1c0f2029e3805ba">00163</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuLogicalBufferStructPtr</a> <a class="code" href="classOgre_1_1GpuProgram.html#a943cefa6be84842ec1c0f2029e3805ba" title="Record of logical to physical buffer maps.">mIntLogicalToPhysical</a>;
<a name="l00168"></a><a class="code" href="classOgre_1_1GpuProgram.html#a420723e4b5097225ce2aaf4e0a3a344c">00168</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuNamedConstantsPtr</a> <a class="code" href="classOgre_1_1GpuProgram.html#a420723e4b5097225ce2aaf4e0a3a344c" title="Parameter name -&gt; ConstantDefinition map, shared instance used by all parameter objects.">mConstantDefs</a>;
<a name="l00170"></a><a class="code" href="classOgre_1_1GpuProgram.html#a1e62196161a4ca6704d02f0b75d2f370">00170</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GpuProgram.html#a1e62196161a4ca6704d02f0b75d2f370" title="File from which to load named constants manually.">mManualNamedConstantsFile</a>;
<a name="l00171"></a><a class="code" href="classOgre_1_1GpuProgram.html#a23f3bb5243cd65bc7b5e625bdbd88c70">00171</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a23f3bb5243cd65bc7b5e625bdbd88c70">mLoadedManualNamedConstants</a>;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00182"></a>00182         <span class="keywordtype">void</span> setupBaseParamDictionary(<span class="keywordtype">void</span>);
<a name="l00183"></a>00183 
<a name="l00186"></a>00186         <span class="keywordtype">bool</span> isRequiredCapabilitiesSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00187"></a>00187 
<a name="l00189"></a><a class="code" href="classOgre_1_1GpuProgram.html#a97ca6090cd137c5c46349174d874bc90">00189</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1GpuProgram.html#a97ca6090cd137c5c46349174d874bc90">calculateSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; } <span class="comment">// TODO </span>
<a name="l00190"></a>00190 
<a name="l00192"></a>00192         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00193"></a>00193 
<a name="l00195"></a>00195         <span class="keywordtype">void</span> createParameterMappingStructures(<span class="keywordtype">bool</span> recreateIfExists = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00197"></a>00197         <span class="keywordtype">void</span> createLogicalParameterMappingStructures(<span class="keywordtype">bool</span> recreateIfExists = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00199"></a>00199         <span class="keywordtype">void</span> createNamedParameterMappingStructures(<span class="keywordtype">bool</span> recreateIfExists = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     <span class="keyword">public</span>:
<a name="l00202"></a>00202 
<a name="l00203"></a>00203         <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00204"></a>00204             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classOgre_1_1GpuProgram.html#afbf0077b4bc78085db991f5e0de81c34">00206</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgram.html#afbf0077b4bc78085db991f5e0de81c34">~GpuProgram</a>() {}
<a name="l00207"></a>00207 
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSourceFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00213"></a>00213 
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; source);
<a name="l00219"></a>00219 
<a name="l00221"></a><a class="code" href="classOgre_1_1GpuProgram.html#a18a12ae49469bcc9bae9b5fde9a0a461">00221</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#a18a12ae49469bcc9bae9b5fde9a0a461" title="Gets the syntax code for this program e.g.">getSyntaxCode</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSyntaxCode; }
<a name="l00222"></a>00222 
<a name="l00224"></a>00224         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSyntaxCode(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntax);
<a name="l00225"></a>00225 
<a name="l00227"></a><a class="code" href="classOgre_1_1GpuProgram.html#a29ef6651dad0349169763940dd40fb8e">00227</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#a29ef6651dad0349169763940dd40fb8e" title="Gets the name of the file used as source for this program.">getSourceFile</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFilename; }
<a name="l00229"></a><a class="code" href="classOgre_1_1GpuProgram.html#a650621cd162bf75a837951f94d1118bb">00229</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#a650621cd162bf75a837951f94d1118bb" title="Gets the assembler source for this program.">getSource</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSource; }
<a name="l00231"></a>00231         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setType(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> t);
<a name="l00233"></a><a class="code" href="classOgre_1_1GpuProgram.html#ac05c53ca118b1ac81fab5981c119bcc0">00233</a>         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="classOgre_1_1GpuProgram.html#ac05c53ca118b1ac81fab5981c119bcc0" title="Get the program type.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00234"></a>00234 
<a name="l00239"></a><a class="code" href="classOgre_1_1GpuProgram.html#af8938cb9c61b7304f97f857a33b56cfc">00239</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* <a class="code" href="classOgre_1_1GpuProgram.html#af8938cb9c61b7304f97f857a33b56cfc" title="Returns the GpuProgram which should be bound to the pipeline.">_getBindingDelegate</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <span class="keyword">this</span>; }
<a name="l00240"></a>00240 
<a name="l00242"></a>00242         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00243"></a>00243 
<a name="l00251"></a>00251         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00252"></a>00252 
<a name="l00259"></a><a class="code" href="classOgre_1_1GpuProgram.html#af337509a5342cb707df4df78337756ae">00259</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSkeletalAnimationIncluded(<span class="keywordtype">bool</span> included) 
<a name="l00260"></a>00260         { mSkeletalAnimation = included; }
<a name="l00261"></a>00261 
<a name="l00268"></a><a class="code" href="classOgre_1_1GpuProgram.html#a84c8bf8460ad30a58d78b5f8fd11e31f">00268</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a84c8bf8460ad30a58d78b5f8fd11e31f" title="Returns whether a vertex program includes the required instructions to perform skeletal animation...">isSkeletalAnimationIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletalAnimation; }
<a name="l00269"></a>00269 
<a name="l00276"></a><a class="code" href="classOgre_1_1GpuProgram.html#a843c706f65d219c1d04b8aeacc4bd3c8">00276</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMorphAnimationIncluded(<span class="keywordtype">bool</span> included) 
<a name="l00277"></a>00277         { mMorphAnimation = included; }
<a name="l00278"></a>00278 
<a name="l00286"></a><a class="code" href="classOgre_1_1GpuProgram.html#a848bf4164963cf8c0435c972eb717e0f">00286</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPoseAnimationIncluded(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> poseCount) 
<a name="l00287"></a>00287         { mPoseAnimation = poseCount; }
<a name="l00288"></a>00288 
<a name="l00295"></a><a class="code" href="classOgre_1_1GpuProgram.html#ac99c378926faac21f6acd6c856fbd04d">00295</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#ac99c378926faac21f6acd6c856fbd04d" title="Returns whether a vertex program includes the required instructions to perform morph animation...">isMorphAnimationIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMorphAnimation; }
<a name="l00296"></a>00296 
<a name="l00303"></a><a class="code" href="classOgre_1_1GpuProgram.html#ae3aa42c5d796c9520880ad7d10dace77">00303</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#ae3aa42c5d796c9520880ad7d10dace77" title="Returns whether a vertex program includes the required instructions to perform pose animation...">isPoseAnimationIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPoseAnimation &gt; 0; }
<a name="l00307"></a><a class="code" href="classOgre_1_1GpuProgram.html#ab3eef54ad776352d6fcf547c77b4a0bc">00307</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1GpuProgram.html#ab3eef54ad776352d6fcf547c77b4a0bc" title="Returns the number of simultaneous poses the vertex program can blend, for use in pose animation...">getNumberOfPosesIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPoseAnimation; }
<a name="l00311"></a><a class="code" href="classOgre_1_1GpuProgram.html#a463bffd1f68fc8ae3c29d64402e9ca8d">00311</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GpuProgram.html#a463bffd1f68fc8ae3c29d64402e9ca8d" title="Sets whether this vertex program requires support for vertex texture fetch from the hardware...">setVertexTextureFetchRequired</a>(<span class="keywordtype">bool</span> r) { mVertexTextureFetch = r; }
<a name="l00315"></a><a class="code" href="classOgre_1_1GpuProgram.html#a37a22b8b6432ed18f2e70bb99f7df7fc">00315</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a37a22b8b6432ed18f2e70bb99f7df7fc" title="Returns whether this vertex program requires support for vertex texture fetch from the hardware...">isVertexTextureFetchRequired</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexTextureFetch; }
<a name="l00316"></a>00316 
<a name="l00320"></a><a class="code" href="classOgre_1_1GpuProgram.html#a39b43157d6b40626101e5de8f9c77bf5">00320</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GpuProgram.html#a39b43157d6b40626101e5de8f9c77bf5" title="Sets whether this geometry program requires adjacency information from the input primitives.">setAdjacencyInfoRequired</a>(<span class="keywordtype">bool</span> r) { mNeedsAdjacencyInfo = r; }
<a name="l00324"></a><a class="code" href="classOgre_1_1GpuProgram.html#ac3d9456e0be1449b03a196f7a56f9af5">00324</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#ac3d9456e0be1449b03a196f7a56f9af5" title="Returns whether this geometry program requires adjacency information from the input primitives...">isAdjacencyInfoRequired</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNeedsAdjacencyInfo; }
<a name="l00325"></a>00325         
<a name="l00336"></a>00336         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> getDefaultParameters(<span class="keywordtype">void</span>);
<a name="l00337"></a>00337 
<a name="l00340"></a><a class="code" href="classOgre_1_1GpuProgram.html#a0d7d2f959ac2ae463db180043990a0cc">00340</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a0d7d2f959ac2ae463db180043990a0cc" title="Returns true if default parameters have been set up.">hasDefaultParameters</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mDefaultParams.isNull(); }
<a name="l00341"></a>00341 
<a name="l00348"></a><a class="code" href="classOgre_1_1GpuProgram.html#a13e91fd91fef3ddaa73300eabbc3dba0">00348</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a13e91fd91fef3ddaa73300eabbc3dba0" title="Returns whether a vertex program wants light and material states to be passed through fixed pipeline ...">getPassSurfaceAndLightStates</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00349"></a>00349 
<a name="l00358"></a><a class="code" href="classOgre_1_1GpuProgram.html#ad467d6cf55fe3d604db8f48715deb722">00358</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#ad467d6cf55fe3d604db8f48715deb722" title="Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API ...">getPassFogStates</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00359"></a>00359 
<a name="l00366"></a><a class="code" href="classOgre_1_1GpuProgram.html#a47a8eeb180ac001c47f3099d31069f92">00366</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a47a8eeb180ac001c47f3099d31069f92" title="Returns whether a vertex program wants transform state to be passed through fixed pipeline low level ...">getPassTransformStates</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00367"></a>00367 
<a name="l00371"></a>00371         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00372"></a>00372 
<a name="l00375"></a><a class="code" href="classOgre_1_1GpuProgram.html#a90e62ce72ddc9eb0fc7573d0cb52ac0e">00375</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgram.html#a90e62ce72ddc9eb0fc7573d0cb52ac0e" title="Did this program encounter a compile error when loading?">hasCompileError</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCompileError; }
<a name="l00376"></a>00376 
<a name="l00379"></a><a class="code" href="classOgre_1_1GpuProgram.html#a2443ed18b880eb939123bb8daf9165c7">00379</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GpuProgram.html#a2443ed18b880eb939123bb8daf9165c7" title="Reset a compile error if it occurred, allowing the load to be retried.">resetCompileError</a>(<span class="keywordtype">void</span>) { mCompileError = <span class="keyword">false</span>; }
<a name="l00380"></a>00380 
<a name="l00389"></a>00389         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setManualNamedConstants(<span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; namedConstants);
<a name="l00390"></a>00390 
<a name="l00392"></a><a class="code" href="classOgre_1_1GpuProgram.html#a6a0752ce0393f5c4cb4773d021b2a3eb">00392</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#a6a0752ce0393f5c4cb4773d021b2a3eb" title="Get a read-only reference to the named constants registered for this program (manually or automatical...">getNamedConstants</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> *mConstantDefs.get(); }
<a name="l00393"></a>00393 
<a name="l00404"></a>00404         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setManualNamedConstantsFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; paramDefFile);
<a name="l00405"></a>00405 
<a name="l00409"></a><a class="code" href="classOgre_1_1GpuProgram.html#a4aa13199b95d110b9a0d907bd1455683">00409</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#a4aa13199b95d110b9a0d907bd1455683" title="Gets the name of a file from which to load named parameters mapping for a program which would not be ...">getManualNamedConstantsFile</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mManualNamedConstantsFile; }
<a name="l00416"></a><a class="code" href="classOgre_1_1GpuProgram.html#ae0feb9efaa1e2c867430520662519a60">00416</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; <a class="code" href="classOgre_1_1GpuProgram.html#ae0feb9efaa1e2c867430520662519a60" title="Get the full list of named constants.">getConstantDefinitions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> *mConstantDefs.get(); }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419     <span class="keyword">protected</span>:
<a name="l00421"></a>00421         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>) = 0;
<a name="l00422"></a>00422 
<a name="l00423"></a>00423     };
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00432"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html">00432</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;GpuProgram&gt; 
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434     <span class="keyword">public</span>:
<a name="l00435"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html#a8cccf8a6f8c4cd8359b672061948d9d4">00435</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html#a8cccf8a6f8c4cd8359b672061948d9d4">GpuProgramPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>&gt;() {}
<a name="l00436"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html#ab0aab65fb57d718d9bde06a311fcda5d">00436</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html#ab0aab65fb57d718d9bde06a311fcda5d">GpuProgramPtr</a>(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>&gt;(rep) {}
<a name="l00437"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html#a20dbea655a7d35d86bfed2a02abf9793">00437</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html#a20dbea655a7d35d86bfed2a02abf9793">GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>&gt;(r) {} 
<a name="l00438"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html#ae741b7f23e217868db507f485638d76a">00438</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>&gt;()
<a name="l00439"></a>00439         {
<a name="l00440"></a>00440             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00441"></a>00441             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00442"></a>00442             {
<a name="l00443"></a>00443                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00444"></a>00444                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00445"></a>00445                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00446"></a>00446                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00447"></a>00447                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00448"></a>00448                 {
<a name="l00449"></a>00449                     ++(*pUseCount);
<a name="l00450"></a>00450                 }
<a name="l00451"></a>00451             }
<a name="l00452"></a>00452         }
<a name="l00453"></a>00453 
<a name="l00455"></a><a class="code" href="classOgre_1_1GpuProgramPtr.html#a6d439ea72fab29d5acf391500ebdd958">00455</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00456"></a>00456         {
<a name="l00457"></a>00457             <span class="keywordflow">if</span> (pRep == static_cast&lt;GpuProgram*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00458"></a>00458                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00459"></a>00459             release();
<a name="l00460"></a>00460             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00461"></a>00461             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00462"></a>00462             {
<a name="l00463"></a>00463                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00464"></a>00464                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00465"></a>00465                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00466"></a>00466                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00467"></a>00467                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00468"></a>00468                 {
<a name="l00469"></a>00469                     ++(*pUseCount);
<a name="l00470"></a>00470                 }
<a name="l00471"></a>00471             }
<a name="l00472"></a>00472             <span class="keywordflow">else</span>
<a name="l00473"></a>00473             {
<a name="l00474"></a>00474                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00475"></a>00475                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00476"></a>00476                 setNull();
<a name="l00477"></a>00477             }
<a name="l00478"></a>00478             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00479"></a>00479         }
<a name="l00481"></a>00481         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; r);
<a name="l00482"></a>00482     };
<a name="l00485"></a>00485 }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
